package k.ld31;

import k.lib.graphics.DisplayObject;

class GraphicalInterface extends DisplayObject {
	// Public layers
	public var back(default,null):DisplayObject;
	public var mid(default,null):DisplayObject;
	public var midtop(default,null):DisplayObject;
	public var top(default,null):DisplayObject;

	// Other attributes
	public var width(default, null):Int;
	public var height(default, null):Int;

	private var fading:Bool;
	private var fade_mask:DisplayObject;
	private var fade_frame:Int;
	private var fade_callback:Void->Void;

	public function new(width:Int, height:Int) {
		super();

		this.width = width;
		this.height = height;
		fading = false;
		fade_frame = 0;

		// Setup layers
		clear();
		back = new DisplayObject(); addChild(back);
		mid = new DisplayObject(); addChild(mid);
		midtop = new DisplayObject(); addChild(midtop);
		top = new DisplayObject(); addChild(top);
	}

	public function clearAll():Void {
		back.clear();
		mid.clear();
		midtop.clear();
		top.clear();
		
		fading = false;
		fade_frame = 0;
	}


	public function update():Void {
		if (fading) {
			if (Tama.frame % 4 == 0) {
				if (Tama.frame - fade_frame > 40) {
					removeChild(fade_mask);
					fading = false;
					fade_callback();
				} else if (fade_mask.alpha < 1) {
					fade_mask.alpha += 0.1;
					fade_frame = Tama.frame;
				}
			}
		}

		back.prepare();
		mid.prepare();
		midtop.prepare();
		top.prepare();
		Spawner.update();
	}

	public function fade(callback:Void->Void):Void {
		if (fading) return;
		fading = true;
		fade_callback = callback;
		fade_frame = Tama.frame;

		fade_mask = new DisplayObject("grid");
		fade_mask.x = Tama.PLATEAU_X;
		fade_mask.y = Tama.PLATEAU_Y;
		fade_mask.alpha = 0.1;
		addChild(fade_mask);
	}
	
}

