package k.ld31;

import flash.Lib;

import k.lib.graphics.DisplayObject;
import k.lib.graphics.Shake;
import k.lib.utils.Color;

class Player extends DisplayObject {
	public var dx:Float;
	public var dy:Float;
	public var lastAngle:Float;
	public var lastShot:Int;
	public var FIRE_DELAY:Int = 10;
	public var lock:Bool;

	public function new(x:Int, y:Int) {
		super("player");
		customx = this.x = x;
		customy = this.y = y;
		lastAngle = 100;
		has_update = true;
		lock = false;
		radius = 8;
		__align = DisplayObject.ALIGN_CENTER;

		shakingColorFilter = Shake.FILTER_HARD;
	}

	override private inline function onUpdate():Void {
		if (!Tama.locked && Tama.state == PLAYING) {
			cx = Tama.toCellX(customx);
			cy = Tama.toCellY(customy);

			var xDistance:Float = Tama.instance.target.x - x;
			var yDistance:Float = Tama.instance.target.y - y;

			if (Tama.instance.monsters.length == 0 || Math.sqrt(yDistance*yDistance + xDistance*xDistance) > 25) {
				var path = Tama.instance.pathfinder.getPath({x: cx, y: cy}, {x: Tama.toCellX(Tama.instance.target.x), y: Tama.toCellY(Tama.instance.target.y)});
				// path = Tama.instance.pathfinder.smooth(path);
				if (path.length > 1 && path[0].x == cx && path[0].y == cy) path.shift();
				
				var dest = path[0];
				if (dest != null) {
					var speed:Float = 7;
					var xDistance:Float = Tama.toAbsoluteX(dest.x) - customx;
					var yDistance:Float = Tama.toAbsoluteY(dest.y) - customy;

					if (Math.sqrt(yDistance*yDistance + xDistance*xDistance) < speed) {
						customx = Tama.toAbsoluteX(dest.x);
						customy = Tama.toAbsoluteY(dest.y);
					} else {
						var radian:Float = Math.atan2(yDistance, xDistance);
						customx += Math.cos(radian) * speed;
						customy += Math.sin(radian) * speed;
					}
					x = Std.int(customx);
					y = Std.int(customy);
				}
			}

			if (Tama.instance.target.x > -1) {
				var xDistance:Float = Lib.current.stage.mouseX - x;
				var yDistance:Float = Lib.current.stage.mouseY - y;
				if (!lock) lastAngle = Math.atan2(yDistance, xDistance);
				if (Tama.instance.monsters.length > 0 && lastAngle != 100) {
					if (lastAngle != 0 && Tama.frame - lastShot > FIRE_DELAY) {
						var shuriken:Shuriken = new Shuriken(x, y, lastAngle);
						Tama.instance.shurikens.addChild(shuriken);
						lastShot = Tama.frame;
					}
				}
			}
		}
	}

}